<?php
/**
 * Cat Groomer functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package cat_groomer
 */

$cat_groomer_theme_data = wp_get_theme();
if( ! defined( 'CAT_GROOMER_THEME_VERSION' ) ) define ( 'CAT_GROOMER_THEME_VERSION', $cat_groomer_theme_data->get( 'Version' ) );
if( ! defined( 'CAT_GROOMER_THEME_NAME' ) ) define( 'CAT_GROOMER_THEME_NAME', $cat_groomer_theme_data->get( 'Name' ) );
if( ! defined( 'CAT_GROOMER_THEME_TEXTDOMAIN' ) ) define( 'CAT_GROOMER_THEME_TEXTDOMAIN', $cat_groomer_theme_data->get( 'TextDomain' ) );

if ( ! defined( 'CAT_GROOMER_VERSION' ) ) {
	define( 'CAT_GROOMER_VERSION', '1.0.0' );
}

if ( ! function_exists( 'cat_groomer_setup' ) ) :
	
	function cat_groomer_setup() {
		
		load_theme_textdomain( 'cat-groomer', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'cat-groomer' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support(
			'custom-background',
			apply_filters(
				'cat_groomer_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );

		/*  Demo Import */
		require get_parent_theme_file_path( '/theme-wizard/config.php' );
	}
endif;
add_action( 'after_setup_theme', 'cat_groomer_setup' );

function cat_groomer_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'cat_groomer_content_width', 640 );
}
add_action( 'after_setup_theme', 'cat_groomer_content_width', 0 );

function cat_groomer_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'cat-groomer' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'cat-groomer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	// Regsiter 4 footer widgets.
	$cat_groomer_footer_widget_column = get_theme_mod('cat_groomer_footer_widget_column','4');
	for ($cat_groomer_i=1; $cat_groomer_i<=$cat_groomer_footer_widget_column; $cat_groomer_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'cat-groomer' )  . $cat_groomer_i,
			'id' => 'cat-groomer-footer-widget-' . $cat_groomer_i,
			'description' => __( 'The Footer Widget Area', 'cat-groomer' )  . $cat_groomer_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'cat_groomer_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function cat_groomer_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Slick style.
	wp_enqueue_style( 'cat-groomer-slick-style', get_template_directory_uri() . '/resource/css/slick' . $min . '.css', array(), '1.8.1' );

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'cat-groomer-style', get_template_directory_uri() . '/style.css', array(), CAT_GROOMER_VERSION );
	
	// RTL style.
	wp_style_add_data('cat-groomer-style', 'rtl', 'replace');

	if (get_theme_mod('cat_groomer_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	// Navigation script.
	wp_enqueue_script( 'cat-groomer-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), CAT_GROOMER_VERSION, true );

	// Slick script.
	wp_enqueue_script( 'cat-groomer-slick-script', get_template_directory_uri() . '/resource/js/slick' . $min . '.js', array( 'jquery' ), '1.8.1', true );

	// Custom script
	wp_enqueue_script( 'cat-groomer-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery' ), CAT_GROOMER_VERSION, true );



	// Localize the sticky header setting
	$cat_groomer_enable_sticky_header = get_theme_mod('cat_groomer_enable_sticky_header', false);
	wp_localize_script( 'cat-groomer-custom-script', 'stickyHeaderSettings', array(
		'isEnabled' => $cat_groomer_enable_sticky_header,
	));

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the webfont.
	wp_enqueue_style(
		'lilita-one',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Lilita+One&display=swap' ),
		array(),
		'1.0'
	);

	wp_enqueue_style(
		'kodchasan',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Kodchasan:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;1,200;1,300;1,400;1,500;1,600;1,700&display=swap' ),
		array(),
		'1.0'
	);

}
add_action( 'wp_enqueue_scripts', 'cat_groomer_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'cat_groomer_products_per_page' );
function cat_groomer_products_per_page( $cols ) {
  	return  get_theme_mod( 'cat_groomer_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'cat_groomer_loop_columns');
	if (!function_exists('cat_groomer_loop_columns')) {
	function cat_groomer_loop_columns() {
		return get_theme_mod( 'cat_groomer_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';


/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function cat_groomer_links_setup() {
	if ( ! defined( 'CAT_GROOMER_PREMIUM_PAGE' ) ) {
	define('CAT_GROOMER_PREMIUM_PAGE',__('https://asterthemes.com/products/pet-house-wordpress-theme/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_THEME_PAGE' ) ) {
		define('CAT_GROOMER_THEME_PAGE',__('https://asterthemes.com/products/cat-groomer','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_SUPPORT' ) ) {
	define('CAT_GROOMER_SUPPORT',__('https://wordpress.org/support/theme/cat-groomer/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_REVIEW' ) ) {
	define('CAT_GROOMER_REVIEW',__('https://wordpress.org/support/theme/cat-groomer/reviews/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_PRO_DEMO' ) ) {
	define('CAT_GROOMER_PRO_DEMO',__('https://demo.asterthemes.com/dog-pet-house/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_THEME_DOCUMENTATION' ) ) {
	define('CAT_GROOMER_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/cat-groomer-free/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_PREMIUM_DOCUMENTATION' ) ) {
	define('CAT_GROOMER_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/dog-pet-house-pro/','cat-groomer'));
	}
	if ( ! defined( 'CAT_GROOMER_BUNDLE_PAGE' ) ) {
		define('CAT_GROOMER_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','cat-groomer'));
	}
}
add_action('after_setup_theme', 'cat_groomer_links_setup');

// Enqueue Customizer live preview script
function cat_groomer_customizer_live_preview() {
    wp_enqueue_script(
        'cat-groomer-customizer',
        get_template_directory_uri() . '/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'cat_groomer_customizer_live_preview');

// Featured Image Dimension
function cat_groomer_blog_post_featured_image_dimension(){
	if(get_theme_mod('cat_groomer_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// Reset all theme settings
function cat_groomer_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('cat_groomer_banner_button_label_');
		remove_theme_mod('cat_groomer_enable_banner_section');
		remove_theme_mod('cat_groomer_banner_slider_content_type');
		remove_theme_mod('cat_groomer_banner_slider_content_post_');
		remove_theme_mod('cat_groomer_banner_slider_content_page_');
		remove_theme_mod('cat_groomer_banner_button_label_');
		remove_theme_mod('cat_groomer_banner_button_link_');
		remove_theme_mod('cat_groomer_enable_service_section');
		remove_theme_mod('cat_groomer_trending_product_heading');
		remove_theme_mod('cat_groomer_trending_product_category');
		
        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'cat-groomer')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'cat-groomer')));
    }
}
add_action('wp_ajax_cat_groomer_reset_demo_import_settings', 'cat_groomer_reset_demo_import_settings'); 